//===-- temu-c/LegacyEvents.h - Legacy Event Queue API ----------*- C++ -*-===//
//
// T-EMU: The Terma Emulator
// (c) Terma 2015
// Authors: Mattias Holm <maho (at) terma.com>
//
//===----------------------------------------------------------------------===//
#ifndef TEMU_LEGACY_EVENTS_H
#define TEMU_LEGACY_EVENTS_H

#include <stdint.h>
#include "temu-c/Support/Objsys.h"
#include "temu-c/Support/Attributes.h"
#ifdef __cplusplus
extern "C" {
#endif

typedef void (*temu_TimerCb)(void *Sender, void *Data);

#define TEMU_EVENT_NS   (1U << 0)
#define TEMU_EVENT_SYNC (1U << 8)

// Serialisation functions
TEMU_API void temu_serialiseEvents(void *Obj, void *Ctxt) TEMU_DEPRECATED;

TEMU_API void temu_deserialiseEvents(void *Obj, void *Ctxt) TEMU_DEPRECATED;

TEMU_API int64_t temu_triggerFirstTimer(void *Queue, uint32_t Flags) TEMU_DEPRECATED;

TEMU_API int64_t temu_triggerCurrentTimers(void *Queue, int64_t Srt, uint32_t Flags)
  TEMU_DEPRECATED;

TEMU_API int64_t temu_nextTimer(void *Queue, uint32_t Flags) TEMU_DEPRECATED;

TEMU_API void temu_postEvent(void *Queue, temu_TimerCb callback,
                    void *Sender, void *Data, uint64_t Time, uint32_t Flags)
  TEMU_DEPRECATED;

TEMU_API void temu_stackEvent(void *Queue, temu_TimerCb callback,
                     void *Sender, void *Data, uint32_t Flags)
  TEMU_DEPRECATED;

TEMU_API int64_t temu_eventTime(void *Queue, temu_TimerCb callback, void *Sender)
  TEMU_DEPRECATED;

TEMU_API void temu_descheduleEvent(void *Queue, temu_TimerCb callback, void *Sender)
  TEMU_DEPRECATED;

TEMU_API void temu_registerEvent(void *Queue, const char *Name, temu_TimerCb Callback,
                        uint32_t Flags)
  TEMU_DEPRECATED;



typedef struct {
  void (*stackPostEvent)(void *Obj, temu_TimerCb Ev, void *Sender, void *Data,
                         uint32_t Flags)
    TEMU_DEPRECATED;

  void (*postDeltaEvent)(void *Obj, temu_TimerCb Ev, void *Sender, void *Data,
                         int64_t Cycles, uint32_t Flags)
    TEMU_DEPRECATED;

  void (*postAbsoluteEvent)(void *Obj, temu_TimerCb Ev, void *Sender, void *Data,
                            int64_t Cycles, uint32_t Flags)
    TEMU_DEPRECATED;
  int64_t (*getEventDeltaTime)(void *Obj, temu_TimerCb Ev,
                               void *Sender) TEMU_DEPRECATED;
  int64_t (*getEventAbsoluteTime)(void *Obj, temu_TimerCb Ev,
                                  void *Sender) TEMU_DEPRECATED;
  void (*descheduleEvent)(void *Obj, temu_TimerCb Ev, void *Sender,
                          uint32_t Flags) TEMU_DEPRECATED;
  void (*registerEvent)(void *Obj, const char *EvName,
                        void (*Ev)(void *, void *), uint32_t Flags)
    TEMU_DEPRECATED;
} temu_LegacyEventIface;

TEMU_IFACE_REFERENCE_TYPE(temu_LegacyEvent);

#ifdef __cplusplus
}
#endif

#endif
