from ctypes import *
TEMUSupport = CDLL('libTEMUSupport.so')


class MemorySpaceIface(Structure):
  _fields_ = [ 
    ('mapDevice', CFUNCTYPE(c_int, c_void_p, c_uint64, c_uint64, c_void_p, c_uint32)),
    ('setAttr', CFUNCTYPE(None, c_void_p, c_uint64, c_uint64, c_uint)),
    ('clearAttr', CFUNCTYPE(None, c_void_p, c_uint64, c_uint64, c_uint)),
    ('getAttrs', CFUNCTYPE(c_ubyte, c_void_p, c_uint64)),
    ('mapDeviceWithNamedIface', CFUNCTYPE(c_int, c_void_p, c_uint64, c_uint64, c_void_p, c_char_p, c_uint32)),
    ('unmapRange', CFUNCTYPE(c_int, c_void_p, c_uint64, c_uint64))  ]


class MemorySpaceIfaceRef(Structure):
  _fields_ = [ 
    ('Obj', c_void_p),
    ('Iface', POINTER(MemorySpaceIface))  ]

class MemorySpaceIfaceRefArray(Structure):
  _fields_ = [ 
    ('Size', c_uint32),
    ('Reserved', c_uint32),
    ('Ifaces', POINTER(MemorySpaceIfaceRef))  ]

class PDCIface(Structure):
  _fields_ = [ 
    ('getPDC', CFUNCTYPE(c_void_p, c_void_p, c_uint64)),
    ('allocPDC', CFUNCTYPE(None, c_void_p, c_uint64)),
    ('disposePDC', CFUNCTYPE(None, c_void_p, c_uint64)),
    ('writePDC', CFUNCTYPE(None, c_void_p, c_uint64, c_void_p)),
    ('clearPDC', CFUNCTYPE(None, c_void_p, c_uint64))  ]

class PDCIfaceRef(Structure):
  _fields_ = [ 
    ('Obj', c_void_p),
    ('Iface', POINTER(PDCIface))  ]

class PDCIfaceRefArray(Structure):
  _fields_ = [ 
    ('Size', c_uint32),
    ('Reserved', c_uint32),
    ('Ifaces', POINTER(PDCIfaceRef))  ]
memoryRead = TEMUSupport.temu_memoryRead
memoryRead.argtypes = [c_void_p, POINTER(c_uint8), c_uint64, c_uint32, c_int]
memoryRead.restype = c_int

memoryWrite = TEMUSupport.temu_memoryWrite
memoryWrite.argtypes = [c_void_p, c_uint64, POINTER(c_uint8), c_uint32, c_int]
memoryWrite.restype = c_int

memoryMap = TEMUSupport.temu_memoryMap
memoryMap.argtypes = [c_void_p, c_uint64, c_uint64, c_void_p, c_uint32]
memoryMap.restype = c_int

memoryMapNamedIface = TEMUSupport.temu_memoryMapNamedIface
memoryMapNamedIface.argtypes = [c_void_p, c_uint64, c_uint64, c_void_p, c_char_p, c_uint32]
memoryMapNamedIface.restype = c_int

memorySetAttr = TEMUSupport.temu_memorySetAttr
memorySetAttr.argtypes = [c_void_p, c_uint64, c_uint64, c_uint]
memorySetAttr.restype = None

memoryClearAttr = TEMUSupport.temu_memoryClearAttr
memoryClearAttr.argtypes = [c_void_p, c_uint64, c_uint64, c_uint]
memoryClearAttr.restype = None

memoryGetAttrs = TEMUSupport.temu_memoryGetAttrs
memoryGetAttrs.argtypes = [c_void_p, c_uint64]
memoryGetAttrs.restype = c_ubyte

memoryReadPhys32 = TEMUSupport.temu_memoryReadPhys32
memoryReadPhys32.argtypes = [c_void_p, c_uint64, POINTER(c_uint32)]
memoryReadPhys32.restype = c_int

memoryWritePhys32 = TEMUSupport.temu_memoryWritePhys32
memoryWritePhys32.argtypes = [c_void_p, c_uint64, c_uint32]
memoryWritePhys32.restype = c_int

normaliseWrite32 = TEMUSupport.temu_normaliseWrite32
normaliseWrite32.argtypes = [c_uint32, c_uint32, c_int, c_int]
normaliseWrite32.restype = c_uint32

normaliseRead32 = TEMUSupport.temu_normaliseRead32
normaliseRead32.argtypes = [c_uint32, c_int, c_int]
normaliseRead32.restype = c_uint32

normaliseRead16 = TEMUSupport.temu_normaliseRead16
normaliseRead16.argtypes = [c_uint16, c_int, c_int]
normaliseRead16.restype = c_uint16

normaliseWrite16 = TEMUSupport.temu_normaliseWrite16
normaliseWrite16.argtypes = [c_uint16, c_uint16, c_int, c_int]
normaliseWrite16.restype = c_uint16

